import java.util.*;
import java.util.*;
import java.net.*;
import java.io.*;

public class Sample {
    public static String getNameOfAirport(String iata) throws IOException {
    var url = "https://soa.smext.faa.gov/asws/api/airport/status/" + iata;

    try(var scanner = new Scanner(new URL(url).openStream())) {
      var response = scanner.nextLine();

      if(!response.contains("Name")) {
	throw new RuntimeException("Invalid airport code " + iata);
      }

      return response.split("\"")[3];
      //way too lazy to do the real work to get the data
    }
  }

  interface FunctionEx<T, R> {
    public R apply(T input) throws Exception;
  }

  //DON't DO THIS
  <T, R> Function<T, R> convertToRuntimeException(FunctionEx<T, R> func) {
    return input -> {
      try {
        return func.apply(input);
      } catch(Exception ex) {
        throw new RuntimeException(ex);
      }
    };
  }

  public static void main(String[] args) {
    List<String> iataCodes = List.of("AUS", "IAH", "DFW", "TAS", "SAT");

    iataCodes.stream()
      .map(convertToRuntimeException(iataCode -> 
        getNameOfAirport(iataCode)))
      .forEach(System.out::println);
  }
}

